#ifndef XS_TEST_EXPECTATION_H_INCLUDED
#define XS_TEST_EXPECTATION_H_INCLUDED

#include <nlohmann/json.hpp>

#include <string>


namespace xs { namespace test
{
    class Expectation
    {
    public:
        Expectation() = delete;
        Expectation(const Expectation&) = delete;
        Expectation(Expectation&&) noexcept = default;
        ~Expectation() noexcept = default;

        Expectation& operator=(const Expectation&) = delete;
        Expectation& operator=(Expectation&&) = delete;

        explicit Expectation(const nlohmann::json& object);
        static bool verify(const nlohmann::json& object) noexcept;

    private:
        Expectation(std::string name, nlohmann::json value) noexcept;

    public:
        std::string name_;
        nlohmann::json value_;
    };
} }

#endif
