#include "test/Expectation.h"

#include <nlohmann/json.hpp>


namespace xs { namespace test
{
    Expectation::Expectation(const nlohmann::json& object)
    : Expectation(object["command"].get<std::string>(), object["expect"])
    { }

    bool Expectation::verify(const nlohmann::json& object) noexcept
    {
        if (!(object.is_object() 
              && object.count("command")
              && object.count("expect"))) {
            return false;
        }

        return (
            object["command"].is_string()
            && (
                object["expect"].is_string() || object["expect"].is_object()
            )
        );
    }

    Expectation::Expectation(std::string name, nlohmann::json value) noexcept
    : name_(std::move(name))
    , value_(std::move(value))
    { }
} }
